#!/usr/local/bin/perl

#------------------------------------------------------------------------------
# HTTP EnvironmentParameter Viewer (utf-8)
# v0.2.1(2006-7-23)
#
# atelier-blue 利都(rito)
# http://www.atelier-blue.com/
#------------------------------------------------------------------------------

&header('HTTP環境変数表示','./standard.css');

print '<p>作成：「<a href="http://www.atelier-blue.com/">Atelier Blue アトリエブルー</a>」</p>';

print "<h1>HTTP環境変数表示</h1>\n" ;
print "<p>HTTPの環境変数を表示します。</p>\n" ;

print "<table border=\"2\">";
&env_print("REMOTE_HOST","自分のホスト名");
&env_print("REMOTE_ADDR","自分のIPアドレス");
&env_print("HTTP_REFERER","直前まで見ていたページ");
&env_print("HTTP_USER_AGENT" ,"ブラウザや環境等の情報");
&env_print("HTTP_ACCEPT" ,"自分が受け付けるMIMEタイプ");
&env_print("HTTP_ACCEPT_LANGUAGE","自分が受け入れる言語の種類" );
&env_print("HTTP_ACCEPT_ENCODING","自分が受け入れ可能な<br />ファイルのエンコード方式" );
&env_print("HTTP_HOST" ,"自分がアクセスしている<br />ホスト情報（ホスト名:ポート）");
&env_print("HTTP_CONNECTION" ,"httpの接続方式");
print "</table>";

print "<p>ソースコードはこちらにあります。役に立たないでしょうがどうぞ。<a href=\"http://www.atelier-blue.com/cgi-bin/http_viewer/http_viewer.txt\">ソースコード</a></p>";
print "<p>CSS付きのzipファイルはこちら。<a href=\"http://www.atelier-blue.com/cgi-bin/http_viewer/http_viewer.zip\">zipファイル</a></p>";

print '<div class="copyright">';
print '    (c) 2006,Atelier Blue (Rito)';
print '    <address class="mail_address"><a href="mailto:webmaster@atelier-blue.com">webmaster@atelier-blue.com</a></address>';
print '</div>';
print '<p>作成：「<a href="http://www.atelier-blue.com/">Atelier Blue アトリエブルー</a>」</p>';

&footer;


exit;

#----------------------------------------------------------------------#
#HTMLヘッダー書き出し
#	引数：HTMLのタイトル,headの拡張中身
#	返り値：特になし
#	呼び出し例：&header_plus('MyPage','<link... />') ;
#----------------------------------------------------------------------#
sub header_plus { 
	#引数としてHTMLのタイトルとheadの拡張中身を受け取る
	my($html_title,$html_custom_head) = @_ ;
	
	print "Content-Type: text/html; charset=utf-8\n\n" ;
	print "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n" ;
	print "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\"\n" ;
	print "     \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">\n" ;
	print "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"ja\">\n" ;
	print "<head>\n" ;
	print "<title>$html_title</title>\n" ;
	print "$html_custom_head\n" ;
	print "</head>\n" ;
	print "<body>\n" ;
}
#----------------------------------------------------------------------#
#HTMLヘッダー書き出し
#	引数：HTMLのタイトル,スタイルシートのパス
#	返り値：特になし
#	呼び出し例：&header('MyPage','./css.css') ;
#----------------------------------------------------------------------#
sub header { 
	#引数としてHTMLのタイトルとBODYタグを受け取る
	my($html_title,$css_path) = @_ ;
	
	print "Content-Type: text/html; charset=utf-8\n\n" ;
	print "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n" ;
	print "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\"\n" ;
	print "     \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">\n" ;
	print "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"ja\">\n" ;
	print "<head>\n" ;
	print "<title>$html_title</title>\n" ;
	if($css_path ne ""){
		print "<link rel=\"stylesheet\" type=\"text/css\" href=\"$css_path\" />\n" ;
	}
	print "</head>\n" ;
	print "<body>\n" ;
}

#----------------------------------------------------------------------#
#HTMLフッター書き出し
#	引数：特になし
#	返り値：特になし
#	呼び出し例：&footer ;
#----------------------------------------------------------------------#
sub footer { 
	print "</body></html>\n";
}

#----------------------------------------------------------------------#
#HTTP環境変数をテーブルの１行形式で書き出し
#	引数：HTTP環境変数の名前,説明
#	返り値：特になし
#	呼び出し例：&env_print('REMOTE_HOST',"説明") ;
#----------------------------------------------------------------------#
sub env_print {
	print "<tr><td><p><strong>$_[0]</strong>";
	if($_[1] ne ""){
		print "<br />$_[1]";
	}
	print "</p></td><td><p>";
	if($ENV{$_[0]} eq ""){
		print "(none)";
	}else{
		print "$ENV{$_[0]}";
	}
	print "</p></td></tr>";
}


__END__

